<script setup lang="ts">
import { onMounted } from "vue";
import { useISAStore } from "@/stores/useISAStore";
const route = useRoute();
const ISAStore = useISAStore();
const dialog = ref(false);
const investigation_to_delete = ref("");
const investigationName = ref(null);
const showDataLinkWizard = ref(false);
const showImportWizard = ref(false);
const isaObject = ref(null);
const path = ref(null);
const depth = ref(0);

const investigationParametersDialog = ref(false);
const investigationLeaveDialog = ref(false);
const snackbarMessage = ref("");
const snackbarMessageType = ref("");

onMounted(() => {
	investigationName.value.focus();
});

// retrieve investigation data
if (ISAStore.investigations.size == 0) {
	await ISAStore.fetchInvestigations();
}

if (!ISAStore.setCurrentInvestigation(+route.params.iid)) {
	// 404
}

await ISAStore.fetchStudies(+route.params.iid);

async function importDemoInvestigation() {
	await ISAStore.updateInvestigationByADemo(ISAStore.currentInvestigation);
}

function activateInvestigation() {
	ISAStore.currentInvestigation.status = "active";
	saveCurrentInvestigation();
}

function saveCurrentInvestigation() {
	ISAStore.addUpdatedInvestigation(ISAStore.currentIid);
}

async function deleteCurrentInvestigation() {
	await ISAStore.deleteCurrentInvestigation();
	dialog.value = false;
	if (ISAStore.investigations.size == 0) {
		navigateTo("/investigations/first");
	} else {
		navigateTo(
			"/investigations/" + Array.from(ISAStore.investigations.values())[0].id
		);
	}
}

async function newStudy() {
	let study = await ISAStore.createPendingStudy(ISAStore.currentIid);
	navigateTo(
		"/investigations/i" + ISAStore.currentIid + "/studies/" + study.id
	);
}
</script>

<template>
  <ImportWizard
    v-model="showImportWizard"
    :isaObject="ISAStore.currentInvestigation"
    :investigationId="ISAStore.currentIid"
  />
  <v-dialog v-model="dialog" width="500">
    <v-card>
      <v-card-title
        >Do you really want to delete this investigation ?</v-card-title
      >
      <v-card-text>
        <p>
          By deleting this investigation all the associated studies and assays,
          as well as the data links will be deleted.
        </p>

        <div v-if="ISAStore.currentInvestigation.name">
          <p class="mt-2">To confirm, type the name of the investigation :</p>

          <v-text-field
            v-if="
              investigation_to_delete != ISAStore.currentInvestigation.name &&
              ISAStore.currentInvestigation.name
            "
            label="Investigation name"
            autofocus
            variant="solo"
            v-model="investigation_to_delete"
          ></v-text-field>
          <v-text-field
            v-else
            label="Investigation name"
            variant="solo"
            autofocus
            v-model="investigation_to_delete"
            @keyup.enter="deleteCurrentInvestigation()"
          ></v-text-field>
        </div>
      </v-card-text>
      <v-card-actions>
        <v-btn @click="dialog = false">Cancel</v-btn>
        <v-btn
          color="error"
          @click="deleteCurrentInvestigation()"
          :disabled="
            investigation_to_delete != ISAStore.currentInvestigation.name &&
            ISAStore.currentInvestigation.name
          "
          >Delete the investigation</v-btn
        >
      </v-card-actions>
    </v-card>
  </v-dialog>

  <div class="pa-1 d-flex flex-row">
    <v-breadcrumbs class="pa-0">
      <v-breadcrumbs-item
        :title="
          ISAStore.currentInvestigation.name
            ? ISAStore.currentInvestigation.name
            : 'No name'
        "
        disabled
      ></v-breadcrumbs-item>
    </v-breadcrumbs>
    <v-chip class="mr-auto ma-2" size="small">
      <span v-if="ISAStore.hasPendingModification">Saving...</span>
      <span v-if="!ISAStore.hasPendingModification">Everything saved</span>
    </v-chip>
    <div>
      <v-menu>
        <template v-slot:activator="{ props }">
          <v-btn
            icon="mdi-dots-horizontal"
            variant="plain"
            size="small"
            v-bind="props"
          ></v-btn>
        </template>
        <v-list density="compact">
          <v-list-item
            title="Delete"
            @click="
              investigation_to_delete = '';
              dialog = true;
            "
          >
            <template v-slot:prepend>
              <v-icon icon="mdi-trash-can-outline"></v-icon>
            </template>
          </v-list-item>
          <v-list-item
            title="Manage members"
            @click="investigationParametersDialog = true"
          >
            <template v-slot:prepend>
              <v-icon icon="mdi-cog"></v-icon>
            </template>
          </v-list-item>
          <v-list-item
            title="Leave the investigation"
            color="error"
            @click="investigationLeaveDialog = true"
          >
            <template v-slot:prepend>
              <v-icon icon="mdi-exit-to-app" color="error"></v-icon>
            </template>
          </v-list-item>
        </v-list>
      </v-menu>
    </div>
  </div>

  <div class="pa-4 pt-0">
    <h1>
      <v-text-field
        ref="investigationName"
        v-model="ISAStore.currentInvestigation.name"
        @update:model-value="saveCurrentInvestigation()"
        placeholder="No name"
        variant="plain"
        prepend-inner-icon="mdi-feather"
        class="isa_name"
      >
      </v-text-field>
    </h1>
    <small class="pa-0">Investigation</small>

    <div v-if="ISAStore.currentInvestigation.status == 'pending'">
      <div class="mt-4">Choose how to create this investigation...</div>
      <v-list class="pa-0" density="compact">
        <v-list-item class="pa-0"
          ><v-btn
            color="primary"
            size="small"
            class="mt-2"
            style="width: 200px;"
            @click="activateInvestigation()"
            >Empty investigation</v-btn
          ></v-list-item
        >
        <v-list-item class="pa-0"
          ><v-btn
            color="primary"
            size="small"
            class="mt-2"
            style="width: 200px;"
            @click="showImportWizard = true"
            >Import from...</v-btn
          ></v-list-item
        >
        <v-list-item class="pa-0"
          ><v-btn
            color="primary"
            size="small"
            class="mt-2"
            style="width: 200px;"
            @click="importDemoInvestigation()"
            >Demo investigation</v-btn
          ></v-list-item
        >
      </v-list>
    </div>

    <v-row v-if="ISAStore.currentInvestigation.status != 'pending'">
      <v-col>
        <v-textarea
          v-model="ISAStore.currentInvestigation.description"
          placeholder="No description"
          variant="plain"
          rows="1"
          auto-grow
          @update:model-value="saveCurrentInvestigation()"
        ></v-textarea>

        <DataLinkList
          :isaObject="ISAStore.currentInvestigation"
          :investigationId="ISAStore.currentIid"
        />

        <v-row align="center">
          <v-col><h2 class="mt-4">Studies</h2></v-col>
          <v-col cols="auto">
            <v-btn size="small" color="primary" @click="newStudy()"
              >New study</v-btn
            ></v-col
          >
        </v-row>

        <v-table
          v-if="ISAStore.currentInvestigation?.studies.size > 0"
          density="compact"
          class="mt-2 pointer-cursor"
        >
          <tbody>
            <tr
              v-for="study in ISAStore.currentInvestigation?.studies.values()"
              @click="
                navigateTo(
                  '/investigations/i' +
                    ISAStore.currentInvestigation.id +
                    '/studies/' +
                    study.id +
                    '/'
                )
              "
            >
              <td>
                <v-icon icon="mdi-notebook-outline" size="small"></v-icon
                >{{ study.name ? study.name : "No name" }}
              </td>
            </tr>
          </tbody>
        </v-table>
        <div
          v-if="ISAStore.currentInvestigation?.studies.size == 0"
          class="text-caption"
        >
          No study
        </div>
      </v-col>
      <v-divider class="mx-4" vertical> </v-divider>
      <v-col cols="3">
        <h2>Data distribution</h2>
      </v-col>
    </v-row>
  </div>

  <InvestigationsParamaters
    :investigationParametersDialog="investigationParametersDialog"
    @investigationParametersDialog="investigationParametersDialog = false"
  />

  <InvestigationsLeave
    :investigationLeaveDialog="investigationLeaveDialog"
    @investigationLeaveDialog="investigationLeaveDialog = false"
    @snackbarMessage="
      (text) => {
        snackbarMessage = text;
        snackbarMessageType = 'error';
      }
    "
  />

  <Snackbar
    :text="snackbarMessage"
    :type="snackbarMessageType"
    @messageDisplayed="
      snackbarMessage = null;
      snackbarMessageType = null;
    "
  />
</template>
